function init()
	RegisterTool("ragdollgun", "Ragdoll Gun", "MOD/main/vox/ragdoll_weapon.vox", 3)
	SetBool("game.tool.ragdollgun.enabled", true)
	if GetInt("savegame.mod.velocity") >= 0 then SetInt("savegame.mod.velocity", -50) end
	spawn = false
	spawnDist = 1.0
	spawnRadius = 0
	spawnRot = 90
end

function draw(dt)
	if GetString("game.player.tool") == "ragdollgun" then
		if GetPlayerScreen() == 0 and GetPlayerVehicle() == 0 and GetPlayerGrabShape() == 0 then
			UiTranslate(UiCenter(), UiHeight()-60)
			UiAlign("center")
			UiPush()
				UiTranslate(0, 10)
				UiAlign("center middle")
				UiFont("bold.ttf", 20)
				UiColor(1, 1, 1, 1)
				UiText("(Pgup/Pgdn) Velocity: "..-vel)
			UiPop()
		end
	end
end

function tick(dt)
	vel = GetInt("savegame.mod.velocity")
	if vel > 0 then SetInt("savegame.mod.velocity", 0) end
	rand = math.random(1, 6)
	ragdoll = "MOD/main/prefab/ragdoll_var"..rand..".xml"
	
	
	if GetString("game.player.tool") == "ragdollgun" then
		local velocity = Vec(0, 0, vel)
		local offset = Transform(Vec(0.03, -1.27, -0.55))
		t = GetCameraTransform()
		trajectory = TransformToParentVec(t, velocity)
		SetToolTransform(offset)
		t.pos = VecAdd(t.pos, TransformToParentVec(t, Vec(0, -1, -3)))
		t.rot = getRotation()
		
		if GetPlayerScreen() == 0 and GetPlayerVehicle() == 0 and GetPlayerGrabShape() == 0 then
			if InputPressed("usetool") then
				local bodies = Spawn(ragdoll, t)
				for i=1,#bodies do
					SetBodyVelocity(bodies[i], trajectory)
				end
			end
			
			if InputDown("grab") then
				spawn = true
			else
				spawn = false
			end
		end
		
		--speed controls
		if InputPressed("pgup") then
			SetInt("savegame.mod.velocity", vel-10)
		end
		if vel < 0 then
			if InputPressed("pgdown") then
				SetInt("savegame.mod.velocity", vel+10)
			end
		end
	end
end

function update(dt)
	if spawn then
		local bodies = Spawn(ragdoll, t)
		for i=1,#bodies do
			SetBodyVelocity(bodies[i], trajectory)
		end
	end
end

function getRotation()
	local fwd = TransformToParentVec(GetCameraTransform(), Vec(0, 0, -1))
	fwd[2] = 0
	fwd = VecNormalize(fwd)
	local angle = math.atan2(-fwd[3], fwd[1]) * 180.0 / math.pi
	return QuatEuler(0, angle + spawnRot, 0)
end




